﻿#region Honorbuddy
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using CommonBehaviors.Actions;
using Action = Styx.TreeSharp.Action;
#endregion

#region System
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
#endregion

namespace AltecWarrior
{
    public class Main : CombatRoutine
    {
        public override string Name { get { return "Altec's WoD Fury / Protection Warrior! v.6.0"; } }

        public override WoWClass Class { get { return WoWClass.Warrior; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit Target { get { return StyxWoW.Me.CurrentTarget; } }

        public override Composite CombatBehavior { get { return Combat(); } }
        public override Composite PreCombatBuffBehavior { get { return CreateBuffs(); } }
        public override Composite CombatBuffBehavior { get { return CreateBuffs(); } }



        public override void Initialize()
        {
            Logging.Write("===============================");
            Logging.Write("Hello there,");
            Logging.Write("Welcome Altec's WoD Warrior v.6.0");
            Logging.Write("This is under MILD Construction!");
            Logging.Write("===============================");
        }

        public static Composite CreateBuffs()
        {
            return new PrioritySelector(
                new Decorator(ret => Me.IsDead || Me.IsGhost || Me.IsCasting || Me.IsChanneling || Me.IsFlying, new ActionAlwaysSucceed()),
                new Decorator(ret => Battle_Shout(), new Action(delegate { CastSpell("Battle Shout", Target, 3); return RunStatus.Failure; })),
                new Decorator(ret => Commanding_Shout(), new Action(delegate { CastSpell("Commanding Shout", Target, 3); return RunStatus.Failure; }))
            );
        }

        public static Composite Combat()
        {
            return new PrioritySelector(
                new Decorator(ret => Me.IsDead || Me.IsGhost || Me.IsCasting || Me.IsChanneling || Me.IsFlying, new ActionAlwaysSucceed()),
                //healing
                new Decorator(ret => Enraged_Regeneration(), new Action(delegate { CastSpell("Enraged Regeneration", Target, 0); return RunStatus.Failure; })),
                new Decorator(ret => Impending_Victory(), new Action(delegate { CastSpell("Impending Victory", Target, 0); return RunStatus.Failure; })),
                new Decorator(ret => Victory_Rush(), new Action(delegate { CastSpell("Victory Rush", Target, 0); return RunStatus.Failure; })),
                //talents
                new Decorator(ret => Storm_Bolt(), new Action(delegate { CastSpell("Storm Bolt", Target, 1); return RunStatus.Failure; })),
                //new Decorator(ret => Shockwave(), new Action(delegate { CastSpell("Shockwave", Target, 1); return RunStatus.Failure; })),
                new Decorator(ret => Dragon_Roar(), new Action(delegate { CastSpell("Dragon Roar", Target, 1); return RunStatus.Failure; })),

                new Decorator(ret => Avatar(), new Action(delegate { CastSpell("Avatar", Target, 1); return RunStatus.Failure; })),
                new Decorator(ret => Bloodbath(), new Action(delegate { CastSpell("Bloodbath", Target, 1); return RunStatus.Failure; })),
                new Decorator(ret => Bladestorm(), new Action(delegate { CastSpell("Bladestorm", Target, 1); return RunStatus.Failure; })),
                //offensive CDs
                new Decorator(ret => Berserker_Rage(), new Action(delegate { CastSpell("Berserker Rage", Target, 1); return RunStatus.Failure; })),
                //new Decorator(ret => Heroic_Throw(), new Action(delegate { CastSpell("Heroic Throw", Target, 3); return RunStatus.Failure; })),
                new Decorator(ret => SpellManager.HasSpell("Shield Slam") && Me.HasAura(71), Spec_Prot()),
                new Decorator(ret => SpellManager.HasSpell("Shield Slam") && (Me.HasAura(156291) || Me.HasAura(2457)), Spec_ProtGlad()),
                new Decorator(ret => SpellManager.HasSpell("Bloodthirst"), Spec_Fury())
                );
        }
        public static Composite Spec_Fury()
        {
            return new PrioritySelector(
                new Decorator(ret => Recklessness(), new Action(delegate { CastSpell("Recklessness", Target, 1); return RunStatus.Failure; })),
                //ragedumps
                new Decorator(ret => Execute(), new Action(delegate { CastSpell("Execute", Target, 4); return RunStatus.Failure; })),
                new Decorator(ret => Wild_Strike(), new Action(delegate { CastSpell("Wild Strike", Target, 4); return RunStatus.Failure; })),
                new Decorator(ret => Raging_Blow(), new Action(delegate { CastSpell("Raging Blow", Target, 4); return RunStatus.Failure; })),
                new Decorator(ret => Whirlwind(), new Action(delegate { CastSpell("Whirlwind", Target, 4); return RunStatus.Failure; })),
                //ragebuilders / fillers
                new Decorator(ret => Bloodthirst(), new Action(delegate { CastSpell("Bloodthirst", Target, 3); return RunStatus.Failure; }))
            );
        }

        public static Composite Spec_ProtGlad()
        {
            return new PrioritySelector(
                new Decorator(ret => Thunder_Clap(), new Action(delegate { CastSpell("Thunder Clap", Target, 3); return RunStatus.Failure; })),
                //ragedumps
                new Decorator(ret => Shield_Charge(), new Action(delegate { CastSpell("Shield Charge", Target, 2); return RunStatus.Failure; })),
                new Decorator(ret => Execute(), new Action(delegate { CastSpell("Execute", Target, 4); return RunStatus.Failure; })),
                new Decorator(ret => Heroic_Strike(), new Action(delegate { CastSpell("Heroic Strike", Target, 4); return RunStatus.Failure; })),
                //ragebuilders / fillers
                new Decorator(ret => Shield_Slam(), new Action(delegate { CastSpell("Shield Slam", Target, 3); return RunStatus.Failure; })),
                new Decorator(ret => Revenge(), new Action(delegate { CastSpell("Revenge", Target, 3); return RunStatus.Failure; })),
                new Decorator(ret => Devastate(), new Action(delegate { CastSpell("Devastate", Target, 3); return RunStatus.Failure; }))
            );
        }

        public static Composite Spec_Prot()
        {
            return new PrioritySelector(
                new Decorator(ret => Thunder_Clap(), new Action(delegate { CastSpell("Thunder Clap", Target, 3); return RunStatus.Failure; })),
                //ragedumps
                new Decorator(ret => Shield_Barrier(), new Action(delegate { CastSpell("Shield Barrier", Target, 2); return RunStatus.Failure; })),
                new Decorator(ret => Shield_Block(), new Action(delegate { CastSpell("Shield Block", Target, 2); return RunStatus.Failure; })),
                new Decorator(ret => Execute(), new Action(delegate { CastSpell("Execute", Target, 4); return RunStatus.Failure; })),
                new Decorator(ret => Heroic_Strike(), new Action(delegate { CastSpell("Heroic Strike", Target, 4); return RunStatus.Failure; })),
                //ragebuilders / fillers
                new Decorator(ret => Devastate() && !Target.HasAura("Deep Wounds"), new Action(delegate { CastSpell("Devastate", Target, 3); return RunStatus.Failure; })),
                new Decorator(ret => Shield_Slam(), new Action(delegate { CastSpell("Shield Slam", Target, 3); return RunStatus.Failure; })),
                new Decorator(ret => Revenge(), new Action(delegate { CastSpell("Revenge", Target, 3); return RunStatus.Failure; })),
                new Decorator(ret => Devastate(), new Action(delegate { CastSpell("Devastate", Target, 3); return RunStatus.Failure; }))
            );
        }

        #region Spells
        //buffs
        public static bool Battle_Shout()
        {
            if (SpellManager.HasSpell("Battle Shout")
                && !Me.HasAura("Battle Shout")
                && !Me.HasAura("Horn of Winter")
                && !Me.HasAura("Trueshot Aura")
                && (Me.HasAura(2457) || Me.HasAura(156291)))
            {
                if (SpellManager.CanCast("Battle Shout"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Commanding_Shout()
        {
            if (((Me.GroupInfo.IsInParty || Me.GroupInfo.IsInRaid) && Me.IsInInstance)
                && SpellManager.HasSpell("Commanding Shout")
                && !Me.HasAura("Commanding Shout")
                && !Me.HasAura("Power Word: Fortitude")
                && !Me.HasAura("Blood Pact")
                && !Me.HasAura("Invigorating Roar")
                && !Me.HasAura("Sturdiness")
                && !Me.HasAura("Savage Vigor")
                && !Me.HasAura("Qiraji Fortitude")
                && Me.HasAura(71))
            {
                if (SpellManager.CanCast("Commanding Shout"))
                {
                    return true;
                }
            }
            return false;
        }
        //healing
        public static bool Enraged_Regeneration()
        {

            if (SpellManager.HasSpell("Enraged Regeneration")
                && Me.HealthPercent <= 70
                && GetSpellCooldown("Enraged Regeneration").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Enraged Regeneration"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Impending_Victory()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell(103840)
                && Me.HealthPercent <= 85
                && GetSpellCooldown("Impending Victory").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Impending Victory"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Victory_Rush()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && !SpellManager.HasSpell(103840)
                && SpellManager.HasSpell(34428)
                && Me.HasAura("Victorious")
                && (Me.HealthPercent <= 85 || (Me.ActiveAuras["Victorious"].TimeLeft.Seconds <= 3 && Me.HealthPercent <= 95))
                && GetSpellCooldown("Victory Rush").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Victory Rush"))
                {
                    return true;
                }
            }
            return false;
        }
        //offensive CDs
        public static bool Thunder_Clap()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.Distance <= 12
                && SpellManager.HasSpell("Thunder Clap")
                && (!Target.HasAura("Deep Wounds") || UnfriendlyUnits.Count() >= 2)
                && GetSpellCooldown("Thunder Clap").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Thunder Clap"))
                {
                    return true;
                }
            }
            return false;
        }

        //Shield_Charge
        public static bool Shield_Charge()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.Distance <= 10
                && SpellManager.HasSpell("Shield Charge")
                && Me.HasAura(156291)
                && !Me.HasAura(169667)
                && GetSpellCooldown("Shield Charge").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Shield Charge"))
                {
                    return true;
                }
            }
            return false;
        }

        public static bool Berserker_Rage()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Berserker Rage")
                && !Me.HasAura(12880)
                && Me.CurrentRage <= 90
                && GetSpellCooldown("Berserker Rage").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Berserker Rage"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Heroic_Throw()
        {
            if (Target != null
                && ValidUnit(Target)
                && SpellManager.HasSpell("Heroic Throw")
                && Target.Distance >= 8
                && Target.Distance <= 30
                && GetSpellCooldown("Heroic Throw").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Heroic Throw"))
                {
                    return true;
                }
            }
            return false;
        }

        public static bool Recklessness()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && Target.IsBoss
                && SpellManager.HasSpell("Recklessness")
                && GetSpellCooldown("Recklessness").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Recklessness"))
                {
                    return true;
                }
            }
            return false;
        }
        //talents
        public static bool Dragon_Roar()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Dragon Roar")
                && Me.HasAura("Enrage")
                && (Target.IsBoss || UnfriendlyUnits.Count() >= 2)
                && GetSpellCooldown("Dragon Roar").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Dragon Roar"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Shockwave()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Shockwave")
                && Me.HasAura("Enrage")
                && GetSpellCooldown("Shockwave").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Shockwave"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Storm_Bolt()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Storm Bolt")
                && Me.HasAura("Enrage")
                && GetSpellCooldown("Storm Bolt").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Storm Bolt"))
                {
                    return true;
                }
            }
            return false;
        }

        public static bool Avatar()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Avatar")
                && Me.HasAura("Enrage")
                && GetSpellCooldown("Avatar").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Avatar"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Bladestorm()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Bladestorm")
                && Me.HasAura("Enrage")
                && GetSpellCooldown("Bladestorm").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Bladestorm"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Bloodbath()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Bloodbath")
                && Me.HasAura("Enrage")
                && GetSpellCooldown("Bloodbath").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Bloodbath"))
                {
                    return true;
                }
            }
            return false;
        }
        //Rage Dumps
        public static bool Shield_Barrier()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Shield Barrier")
                && Me.CurrentRage >= 60
                && UnfriendlyUnitsTargetingMe.Count() == 1
                && !Me.HasAura("Shield Barrier"))
            {
                if (SpellManager.CanCast("Shield Barrier"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Shield_Block()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Shield Block")
                && Me.CurrentRage >= 60
                && UnfriendlyUnitsTargetingMe.Count() >= 2
                && !Me.HasAura("Shield Block"))
            {
                if (SpellManager.CanCast("Shield Block"))
                {
                    return true;
                }
            }
            return false;
        }

        public static bool Heroic_Strike()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Heroic Strike")
                && (((Me.HasAura(156291) && Me.HasAura(169667)) || Me.HasAura(2457)) && (Me.CurrentRage >= 50 || Me.HasAura(122510) || (Me.HasAura(169686) && Me.GetAuraById(169686).StackCount > 5)) || (Me.HasAura(71) && (Me.CurrentRage >= 80 || Me.HasAura(122510) || (Me.HasAura(169686) && Me.GetAuraById(169686).StackCount > 5)))))
            {
                if (SpellManager.CanCast("Heroic Strike"))
                {
                    return true;
                }
            }
            return false;
        }

        public static bool Execute()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Execute")
                && Target.HealthPercent < 20
                && (Me.CurrentRage >= 30 || Me.HasAura("Sudden Death")))
            {
                if (SpellManager.CanCast("Execute"))
                {
                    return true;
                }
            }
            return false;
        }

        public static bool Raging_Blow()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Raging Blow")
                && Me.CurrentRage >= 10
                && Me.HasAura(131116))
            {
                if (SpellManager.CanCast("Raging Blow"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Whirlwind()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Whirlwind")
                && UnfriendlyUnits.Count() >= 2
                && Me.CurrentRage >= 30)
            {
                if (SpellManager.CanCast("Whirlwind"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Wild_Strike()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Wild Strike")
                && (Me.CurrentRage >= 45 || Me.HasAura(46916)))
            {
                if (SpellManager.CanCast("Wild Strike"))
                {
                    return true;
                }
            }
            return false;
        }
        //Rage Builders
        public static bool Shield_Slam()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Shield Slam")
                )
            {
                if (SpellManager.CanCast("Shield Slam"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Revenge()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Revenge")
                )
            {
                if (SpellManager.CanCast("Revenge"))
                {
                    return true;
                }
            }
            return false;
        }
        public static bool Devastate()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Devastate"))
            {
                if (SpellManager.CanCast("Devastate"))
                {
                    return true;
                }
            }
            return false;
        }

        public static bool Bloodthirst()
        {
            if (Target != null
                && ValidUnit(Target)
                && Target.IsWithinMeleeRange
                && SpellManager.HasSpell("Bloodthirst")
                && Me.CurrentRage <= 90
                && GetSpellCooldown("Bloodthirst").TotalSeconds <= 0)
            {
                if (SpellManager.CanCast("Bloodthirst"))
                {
                    return true;
                }
            }
            return false;
        }

        /*
        static void UseTrinkets()
        {
            var firstTrinket = StyxWoW.Me.Inventory.Equipped.Trinket1;
            var secondTrinket = StyxWoW.Me.Inventory.Equipped.Trinket2;


            if (firstTrinket != null && CanUseEquippedItem(firstTrinket))
                firstTrinket.Use();


            if (secondTrinket != null && CanUseEquippedItem(secondTrinket))
                secondTrinket.Use();
        }
        private static bool CanUseEquippedItem(WoWItem item)
        {
            string itemSpell = Lua.GetReturnVal<string>("return GetItemSpell(" + item.Entry + ")", 0);
            if (string.IsNullOrEmpty(itemSpell))
                return false;


            return item.Usable && item.Cooldown <= 0;
        }
        */
        #endregion
        #region Spell CD
        public static TimeSpan GetSpellCooldown(string spell)
        {
            SpellFindResults results;
            if (SpellManager.FindSpell(spell, out results))
            {
                if (results.Override != null)
                {
                    return results.Override.CooldownTimeLeft;
                }
                return results.Original.CooldownTimeLeft;
            }


            return TimeSpan.MaxValue;
        }
        public static TimeSpan GetSpellCooldownID(int spell)
        {
            SpellFindResults results;
            if (SpellManager.FindSpell(spell, out results))
            {
                if (results.Override != null)
                    return results.Override.CooldownTimeLeft;
                return results.Original.CooldownTimeLeft;
            }


            return TimeSpan.MaxValue;
        }
        #endregion Spell CD




        #region [Target Checks]
        static IEnumerable<WoWUnit> UnfriendlyUnitsTargetingMe
        {

            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>(false, false).Where(u => !u.IsDead
                    && u.CanSelect
                    && u.Attackable
                    && !u.IsFriendly
                    && u.Distance <= 12
                    && u.IsTargetingMeOrPet);
            }
        }

        static IEnumerable<WoWUnit> UnfriendlyUnits
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>(false, false).Where(u => !u.IsDead
                    && u.CanSelect
                    && u.Attackable
                    && !u.IsFriendly
                    && u.Distance <= 12
                    && (u.Level > 25 || AttackingFriendlies(u)));
            }
        }

        public static bool AttackingFriendlies(WoWUnit u)
        {
            return u.IsTargetingMeOrPet
                || u.IsTargetingMyPartyMember
                || u.IsTargetingMyRaidMember
                || u.IsTargetingAnyMinion;
        }

        public static bool ValidUnit(WoWUnit u)
        {
            if (u == null || !u.IsValid)
            {
                return false;
            }
            if (!u.CanSelect)
            {
                return false;
            }
            if (u.IsDead)
            {
                return false;
            }
            if (u.IsPlayer)
            {
                WoWPlayer up = u.ToPlayer();
                if (up.IsHorde == Me.IsHorde)
                {
                    return false;
                }
                if (up.IsAlliance == Me.IsAlliance)
                {
                    return false;
                }
                if (up.Guid == Me.CurrentTargetGuid && !CanAttackCurrentTarget)
                {
                    return false;
                }
                return true;
            }
            if (u.IsFriendly)
            {
                return false;
            }
            WoWPlayer uOwner = GetPlayerParent(u);
            if (uOwner != null && uOwner.IsAlive && !uOwner.IsMe)
            {
                if (!ValidUnit(uOwner))
                {
                    return false;
                }
                if (!Blacklist.Contains(uOwner, BlacklistFlags.Combat))
                {
                    return false;
                }
                if (!Me.IsPvPFlagged)
                {
                    return false;
                }
            }
            if (u.IsNonCombatPet)
            {
                return false;
            }
            if (IsIgnorableCritter(u))
            {
                return false;
            }
            return true;
        }

        public static bool CanAttackCurrentTarget
        {
            get
            {
                if (StyxWoW.Me.CurrentTarget == null)
                    return false;

                return Lua.GetReturnVal<bool>("return UnitCanAttack(\"player\",\"target\")", 0);
            }
        }

        public static bool IsIgnorableCritter(WoWUnit u)
        {
            if (!u.IsCritter)
                return false;

            // good enemy if BotPoi
            if (Styx.CommonBot.POI.BotPoi.Current.Guid == u.Guid && Styx.CommonBot.POI.BotPoi.Current.Type == Styx.CommonBot.POI.PoiType.Kill)
                return false;

            // good enemy if Targeting
            if (Targeting.Instance.TargetList.Contains(u))
                return false;

            // good enemy if Threat towards us
            if (u.ThreatInfo.ThreatValue != 0 && u.IsTargetingMyRaidMember)
                return false;

            // Nah, just a harmless critter
            return true;
        }

        public static WoWPlayer GetPlayerParent(WoWUnit u)
        {
            // If it is a pet/minion/totem, lets find the root of ownership chain
            WoWUnit pOwner = u;
            while (true)
            {
                if (pOwner.OwnedByUnit != null)
                    pOwner = pOwner.OwnedByRoot;
                else if (pOwner.CreatedByUnit != null)
                    pOwner = pOwner.CreatedByUnit;
                else if (pOwner.SummonedByUnit != null)
                    pOwner = pOwner.SummonedByUnit;
                else
                    break;
            }

            if (u != pOwner && pOwner.IsPlayer)
                return pOwner as WoWPlayer;

            return null;
        }

        #endregion [Target Checks]

        #region [Spell / Logging]
        public static string LastCastSpell = "";
        public static WoWUnit LastCastUnit;
        public static DateTime LastCastTime = DateTime.Now;

        public static readonly Stopwatch LagTimer = new Stopwatch();
        public static string NoGCDSpells = "[Heroic Strike] [Bloodbath] [Berserker Rage] [Shield Wall] [Last Stand] [Mocking Banner] [Demoralizing Shout] [Shield Block] [Shield Barrier] [Charge] [Enraged Regeneration] [Pummel] [Spell Reflection]";
        public static void CastSpell(string spellName, WoWUnit u, int LC)
        {
            if (!ValidUnit(u) || u == null) { return; }
            if (LagTimer.IsRunning && LagTimer.ElapsedMilliseconds < 250) { return; }
            if (!SpellManager.GlobalCooldown || NoGCDSpells.Contains(spellName))
            {
                uint iCR;

                #region [Log Colors]
                Color Lc = Colors.Orange;
                switch (LC)
                {
                    case 0:
                        Lc = Colors.Green;
                        break;
                    case 1:
                        Lc = Colors.LightCoral;
                        break;
                    case 2:
                        Lc = Colors.Blue;
                        break;
                    case 3:
                        Lc = Colors.Yellow;
                        break;
                    case 4:
                        Lc = Colors.Red;
                        break;
                }
                #endregion

                if (SpellManager.CanCast(spellName, u))
                {
                    LagTimer.Reset();
                    iCR = Me.CurrentRage;
                    SpellManager.Cast(spellName, u);
                    LagTimer.Start();
                    Logging.Write(Lc, "{0} - Rage: {1} - Enemy HP: {2}% @ {3} m - Casting: {4}!", DateTime.Now.ToString("mm:ss:fff"), iCR, Math.Round(u.HealthPercent), Math.Round(u.Distance), spellName);
                }
                //else { return; }
            }
            else { return; }
        }
        #endregion [Spell / Logging]

    }
}